diff --git a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/SurfaceGeneratorNether.java b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/SurfaceGeneratorNether.java
index 8d3632cae..5a9b74363 100644
--- a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/SurfaceGeneratorNether.java
+++ b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/SurfaceGeneratorNether.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.world.generate.chunk.perlin.nether;
 
-import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.generate.chunk.ChunkGeneratorResult;
@@ -35,8 +35,8 @@ public class SurfaceGeneratorNether
         int chunkX = chunk.xPosition;
         int chunkZ = chunk.zPosition;
 
-        int oceanBlock = world.getWorldType().getOceanBlock();
-        int worldFillBlock = world.getWorldType().getFillerBlock();
+        int oceanBlock = world.getWorldType().getOceanBlockId();
+        int worldFillBlock = world.getWorldType().getFillerBlockId();
 
         Random rand = new Random((long) chunkX * 0x4F9939F508L + (long) chunkZ * 0x1EF1565BD5L);
 
@@ -89,19 +89,19 @@ public class SurfaceGeneratorNether
                             fillerBlock = (short) worldFillBlock;
                             if(generateGravelBeach)
                             {
-                                topBlock = (short) Block.gravel.id;
+                                topBlock = (short) Blocks.GRAVEL.id;
                             }
                             if(generateGravelBeach)
                             {
-                                fillerBlock = (short) Block.netherrack.id;
+                                fillerBlock = (short) Blocks.NETHERRACK.id;
                             }
                             if(generateSandBeach)
                             {
-                                topBlock = (short) Block.soulsand.id;
+                                topBlock = (short) Blocks.SOULSAND.id;
                             }
                             if(generateSandBeach)
                             {
-                                fillerBlock = (short) Block.soulsand.id;
+                                fillerBlock = (short) Blocks.SOULSAND.id;
                             }
                         }
 
diff --git a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/TerrainGeneratorNether.java b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/TerrainGeneratorNether.java
index c05622134..0a902d2de 100644
--- a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/TerrainGeneratorNether.java
+++ b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/TerrainGeneratorNether.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.world.generate.chunk.perlin.nether;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.generate.chunk.perlin.DensityGenerator;
 import net.minecraft.core.world.generate.chunk.perlin.TerrainGeneratorLerp;
@@ -25,19 +26,19 @@ public class TerrainGeneratorNether
 
         if (y >= type.getMaxY() - rand.nextInt(5))
         {
-            return Block.bedrock.id;
+            return Blocks.BEDROCK.id;
         }
         else if (y <= type.getMinY() + rand.nextInt(5))
         {
-            return Block.bedrock.id;
+            return Blocks.BEDROCK.id;
         }
         else if (density > 0.0)
         {
-            return type.getFillerBlock();
+            return type.getFillerBlockId();
         }
         else if (y >= type.getMinY() && y < type.getMinY() + type.getOceanY())
         {
-            return type.getOceanBlock();
+            return type.getOceanBlockId();
         }
 
         return 0;
diff --git a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
index aa7f16875..fbafb6b93 100644
--- a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
+++ b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
@@ -1,8 +1,16 @@
 package net.minecraft.core.world.generate.chunk.perlin.overworld;
 
+import net.minecraft.core.block.BaseLeavesBlock;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockLeavesBase;
-import net.minecraft.core.block.BlockSand;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.CoalOreBlock;
+import net.minecraft.core.block.DiamondOreBlock;
+import net.minecraft.core.block.GoldOreBlock;
+import net.minecraft.core.block.IronOreBlock;
+import net.minecraft.core.block.LapisOreBlock;
+import net.minecraft.core.block.MossBlock;
+import net.minecraft.core.block.RedstoneOreBlock;
+import net.minecraft.core.block.SandBlock;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biomes;
@@ -49,7 +57,7 @@ public class ChunkDecoratorOverworld
 
         float oreHeightModifier = rangeY / 128f;
 
-        BlockSand.fallInstantly = true;
+        SandBlock.fallInstantly = true;
         int x = chunkX * 16;
         int z = chunkZ * 16;
         int y = world.getHeightValue(x + 16, z + 16);
@@ -70,7 +78,7 @@ public class ChunkDecoratorOverworld
                 {
                     int topBlock = world.getHeightValue(x + dx, z + dz);
                     int id = world.getBlockId(x + dx, topBlock - 1, z + dz);
-                    if (id == Block.grass.id)
+                    if (id == Blocks.GRASS.id)
                     {
                         boolean shouldPlaceWater = swampRand.nextFloat() < 0.5f;
                         if (shouldPlaceWater)
@@ -88,7 +96,7 @@ public class ChunkDecoratorOverworld
                                             negYId != 0 && Block.blocksList[negYId].blockMaterial.isSolid()
                             )
                             {
-                                world.setBlock(x + dx, topBlock - 1, z + dz, Block.fluidWaterStill.id);
+                                world.setBlock(x + dx, topBlock - 1, z + dz, Blocks.FLUID_WATER_STILL.id);
                                 world.setBlock(x + dx, topBlock, z + dz, 0);
                             }
                         }
@@ -103,22 +111,22 @@ public class ChunkDecoratorOverworld
         if (biome == Biomes.OVERWORLD_DESERT)
             lakeChance = 0;
         if (lakeChance != 0 && rand.nextInt(lakeChance) == 0) {
-            int fluid = Block.fluidWaterStill.id;
+            int fluid = Blocks.FLUID_WATER_STILL.id;
             if (biome.hasSurfaceSnow())
             {
-                fluid = Block.ice.id;
+                fluid = Blocks.ICE.id;
             }
             int i1 = x + rand.nextInt(16) + 8;
             int l4 = minY + rand.nextInt(rangeY);
             int i8 = z + rand.nextInt(16) + 8;
-            (new WorldFeatureLake(fluid)).generate(world, rand, i1, l4, i8);
+            (new WorldFeatureLake(fluid)).place(world, rand, i1, l4, i8);
         }
         if (rand.nextInt(8) == 0) {
             int xf = x + rand.nextInt(16) + 8;
             int yf = minY + rand.nextInt(rand.nextInt(rangeY - (rangeY / 16)) + (rangeY / 16));
             int zf = z + rand.nextInt(16) + 8;
             if (yf < minY + rangeY / 2 || rand.nextInt(10) == 0) {
-                (new WorldFeatureLake(Block.fluidLavaStill.id)).generate(world, rand, xf, yf, zf);
+                (new WorldFeatureLake(Blocks.FLUID_LAVA_STILL.id)).place(world, rand, xf, yf, zf);
             }
         }
         for (int k1 = 0; k1 < (8 * oreHeightModifier); k1++) {
@@ -126,9 +134,9 @@ public class ChunkDecoratorOverworld
             int k8 = minY + rand.nextInt(rangeY);
             int j11 = z + rand.nextInt(16) + 8;
             if (rand.nextInt(2) == 0) {
-                (new WorldFeatureDungeon(Block.brickClay.id, Block.brickClay.id, null)).generate(world, rand, j5, k8, j11);
+                (new WorldFeatureDungeon(Blocks.BRICK_CLAY.id, Blocks.BRICK_CLAY.id, null)).place(world, rand, j5, k8, j11);
             } else {
-                (new WorldFeatureDungeon(Block.cobbleStone.id, Block.cobbleStoneMossy.id, null)).generate(world, rand, j5, k8, j11);
+                (new WorldFeatureDungeon(Blocks.COBBLE_STONE.id, Blocks.COBBLE_STONE_MOSSY.id, null)).place(world, rand, j5, k8, j11);
             }
         }
 
@@ -144,7 +152,7 @@ public class ChunkDecoratorOverworld
 
             if (rand.nextInt(700) == 0) {
                 Random lRand = chunk.getChunkRandom(0x4823F58);
-                (new WorldFeatureLabyrinth()).generate(world, lRand, j5, k8, j11);
+                (new WorldFeatureLabyrinth()).place(world, lRand, j5, k8, j11);
             }
         }
 
@@ -152,77 +160,85 @@ public class ChunkDecoratorOverworld
             int k5 = x + rand.nextInt(16);
             int l8 = minY + rand.nextInt(rangeY);
             int k11 = z + rand.nextInt(16);
-            (new WorldFeatureClay(32)).generate(world, rand, k5, l8, k11);
+            (new WorldFeatureClay(32)).place(world, rand, k5, l8, k11);
         }
         if (biome instanceof BiomeOutback || biome == Biomes.OVERWORLD_OUTBACK) {
             int l5 = x + rand.nextInt(16);
             int l11 = z + rand.nextInt(16);
             int i9 = world.getHeightValue(l5, l11);
-            (new WorldFeatureRichScorchedDirt(10)).generate(world, rand, l5, i9, l11);
+            (new WorldFeatureRichScorchedDirt(10)).place(world, rand, l5, i9, l11);
         }
 
+        if (biome == Biomes.OVERWORLD_GLACIER || biome == Biomes.OVERWORLD_TUNDRA){
+            for (int i4 = 0; i4 < 5 * oreHeightModifier; i4++) {
+                int j7 = x + rand.nextInt(16);
+                int k10 = minY + rand.nextInt(rangeY / 2);
+                int j13 = z + rand.nextInt(16);
+                (new WorldFeaturePermaice(32 + rand.nextInt(32), Blocks.PERMAFROST)).place(world, rand, j7, k10, j13);
+            }
+        }
 
         for (int j2 = 0; j2 < (20 * oreHeightModifier); j2++) {
             int l5 = x + rand.nextInt(16);
             int i9 = minY + rand.nextInt(rangeY);
             int l11 = z + rand.nextInt(16);
-            (new WorldFeatureOre(Block.dirt.id, 32, false)).generate(world, rand, l5, i9, l11);
+            (new WorldFeatureOre(Blocks.DIRT.id, 32)).place(world, rand, l5, i9, l11);
         }
 
         for (int k2 = 0; k2 < (10 * oreHeightModifier); k2++) {
             int i6 = x + rand.nextInt(16);
             int j9 = minY + rand.nextInt(rangeY);
             int i12 = z + rand.nextInt(16);
-            (new WorldFeatureOre(Block.gravel.id, 32, false)).generate(world, rand, i6, j9, i12);
+            (new WorldFeatureOre(Blocks.GRAVEL.id, 32)).place(world, rand, i6, j9, i12);
         }
 
         for (int i3 = 0; i3 < (20 * oreHeightModifier); i3++) {
             int j6 = x + rand.nextInt(16);
             int k9 = minY + rand.nextInt(rangeY);
             int j12 = z + rand.nextInt(16);
-            (new WorldFeatureOre(Block.oreCoalStone.id, 16, true)).generate(world, rand, j6, k9, j12);
+            new WorldFeatureOre(CoalOreBlock.variantMap, 16).place(world, rand, j6, k9, j12);
         }
 
         for (int j3 = 0; j3 < (20 * oreHeightModifier); j3++) {
             int k6 = x + rand.nextInt(16);
             int l9 = minY + rand.nextInt(rangeY / 2);
             int k12 = z + rand.nextInt(16);
-            (new WorldFeatureOre(Block.oreIronStone.id, 8, true)).generate(world, rand, k6, l9, k12);
+            (new WorldFeatureOre(IronOreBlock.variantMap, 8)).place(world, rand, k6, l9, k12);
         }
 
         for (int k3 = 0; k3 < (2 * oreHeightModifier); k3++) {
             int l6 = x + rand.nextInt(16);
             int i10 = minY + rand.nextInt(rangeY / 4);
             int l12 = z + rand.nextInt(16);
-            (new WorldFeatureOre(Block.oreGoldStone.id, 8, true)).generate(world, rand, l6, i10, l12);
+            (new WorldFeatureOre(GoldOreBlock.variantMap, 8)).place(world, rand, l6, i10, l12);
         }
 
         for (int l3 = 0; l3 < (8 * oreHeightModifier); l3++) {
             int i7 = x + rand.nextInt(16);
             int j10 = minY + rand.nextInt(rangeY / 8);
             int i13 = z + rand.nextInt(16);
-            (new WorldFeatureOre(Block.oreRedstoneStone.id, 7, true)).generate(world, rand, i7, j10, i13);
+            (new WorldFeatureOre(RedstoneOreBlock.variantMap, 7)).place(world, rand, i7, j10, i13);
         }
 
         for (int i4 = 0; i4 < oreHeightModifier; i4++) {
             int j7 = x + rand.nextInt(16);
             int k10 = minY + rand.nextInt(rangeY / 8);
             int j13 = z + rand.nextInt(16);
-            (new WorldFeatureOre(Block.oreDiamondStone.id, 7, true)).generate(world, rand, j7, k10, j13);
+            (new WorldFeatureOre(DiamondOreBlock.variantMap, 7)).place(world, rand, j7, k10, j13);
         }
 
         for (int i4 = 0; i4 < oreHeightModifier; i4++) {
             int j7 = x + rand.nextInt(16);
             int k10 = minY + rand.nextInt(rangeY / 2);
             int j13 = z + rand.nextInt(16);
-            (new WorldFeatureOre(Block.mossStone.id, 32, true)).generate(world, rand, j7, k10, j13);
+            (new WorldFeatureOre(MossBlock.variantMap, 32)).place(world, rand, j7, k10, j13);
         }
 
         for (int j4 = 0; j4 < oreHeightModifier; j4++) {
             int k7 = x + rand.nextInt(16);
             int l10 = minY + rand.nextInt(rangeY / 8) + rand.nextInt(rangeY / 8);
             int k13 = z + rand.nextInt(16);
-            (new WorldFeatureOre(Block.oreLapisStone.id, 6, true)).generate(world, rand, k7, l10, k13);
+            (new WorldFeatureOre(LapisOreBlock.variantMap, 6)).place(world, rand, k7, l10, k13);
         }
 
 
@@ -273,16 +289,16 @@ public class ChunkDecoratorOverworld
         }
         if (treeDensityOverride != -1) treeDensity = treeDensityOverride;
         try {
-        	BlockLeavesBase.enableDecay = false;
+        	BaseLeavesBlock.enableDecay = false;
             for (int i11 = 0; i11 < treeDensity; i11++) {
                 int l13 = x + rand.nextInt(16) + 8;
                 int j14 = z + rand.nextInt(16) + 8;
                 WorldFeature feature = biome.getRandomWorldGenForTrees(rand);
-                feature.func_517_a(1.0D, 1.0D, 1.0D);
-                feature.generate(world, rand, l13, world.getHeightValue(l13, j14), j14);
+                feature.init(1.0D, 1.0D, 1.0D);
+                feature.place(world, rand, l13, world.getHeightValue(l13, j14), j14);
             }
         }finally {
-        	BlockLeavesBase.enableDecay = true;
+        	BaseLeavesBlock.enableDecay = true;
         }
         byte byteReeds = 0;
         if (biome == Biomes.OVERWORLD_RAINFOREST) {
@@ -292,7 +308,7 @@ public class ChunkDecoratorOverworld
             int i18 = x + rand.nextInt(16) + 8;
             int i23 = z + rand.nextInt(16) + 8;
             int i21 = world.getHeightValue(i18, i23);
-            (new WorldFeatureSugarCaneTall()).generate(world, rand, i18, i21, i23);
+            (new WorldFeatureSugarCaneTall()).place(world, rand, i18, i21, i23);
         }
 
         byte byteOrchid = 0;
@@ -303,12 +319,12 @@ public class ChunkDecoratorOverworld
             byteOrchid = 1;
         }
         for (int l14 = 0; l14 < byteOrchid; l14++) {
-            int[] flowerIds= { Block.flowerYellow.id, Block.flowerPink.id, Block.flowerRed.id };
+            int[] flowerIds= { Blocks.FLOWER_YELLOW.id, Blocks.FLOWER_PINK.id, Blocks.FLOWER_RED.id };
 
             int l19 = x + rand.nextInt(16) + 8;
             int k22 = rand.nextInt(world.getHeightBlocks());
             int j24 = z + rand.nextInt(16) + 8;
-            (new WorldFeatureMeadow(flowerIds)).generate(world, rand, l19, k22, j24);
+            (new WorldFeatureMeadow(flowerIds)).place(world, rand, l19, k22, j24);
         }
 
         byte byteMeadow = 0;
@@ -326,17 +342,17 @@ public class ChunkDecoratorOverworld
         }
 
         for (int l14 = 0; l14 < byteMeadow; l14++) {
-            int blockId = Block.flowerPurple.id;
+            int blockId = Blocks.FLOWER_PURPLE.id;
             if (rand.nextInt(12) == 0) {
-                blockId = Block.flowerRed.id;
+                blockId = Blocks.FLOWER_RED.id;
             }
             if (rand.nextInt(6) == 0) {
-                blockId = Block.flowerYellow.id;
+                blockId = Blocks.FLOWER_YELLOW.id;
             }
             int l19 = x + rand.nextInt(16) + 8;
             int k22 = rand.nextInt(world.getHeightBlocks());
             int j24 = z + rand.nextInt(16) + 8;
-            (new WorldFeatureTallGrass(blockId)).generate(world, rand, l19, k22, j24);
+            (new WorldFeatureTallGrass(blockId)).place(world, rand, l19, k22, j24);
         }
 
         byte byteBluebells = 0;
@@ -357,7 +373,7 @@ public class ChunkDecoratorOverworld
             int k14 = x + rand.nextInt(16) + 8;
             int l16 = minY + rand.nextInt(rangeY);
             int k19 = z + rand.nextInt(16) + 8;
-            (new WorldFeatureFlowers(Block.flowerLightBlue.id)).generate(world, rand, k14, l16, k19);
+            (new WorldFeatureFlowers(Blocks.FLOWER_LIGHT_BLUE.id)).place(world, rand, k14, l16, k19);
         }
 
         byte byteMarigold = 0;
@@ -380,7 +396,7 @@ public class ChunkDecoratorOverworld
             int k14 = x + rand.nextInt(16) + 8;
             int l16 = minY + rand.nextInt(rangeY);
             int k19 = z + rand.nextInt(16) + 8;
-            (new WorldFeatureFlowers(Block.flowerOrange.id)).generate(world, rand, k14, l16, k19);
+            (new WorldFeatureFlowers(Blocks.FLOWER_ORANGE.id)).place(world, rand, k14, l16, k19);
         }
 
         byte byte0 = 0;
@@ -408,7 +424,7 @@ public class ChunkDecoratorOverworld
             int k14 = x + rand.nextInt(16) + 8;
             int l16 = minY + rand.nextInt(rangeY);
             int k19 = z + rand.nextInt(16) + 8;
-            (new WorldFeatureFlowers(Block.flowerYellow.id)).generate(world, rand, k14, l16, k19);
+            (new WorldFeatureFlowers(Blocks.FLOWER_YELLOW.id)).place(world, rand, k14, l16, k19);
         }
 
         byte byte1 = 0;
@@ -443,14 +459,14 @@ public class ChunkDecoratorOverworld
             byte1 = 2;
         }
         for (int l14 = 0; l14 < byte1; l14++) {
-            int type = Block.tallgrass.id;
+            int type = Blocks.TALLGRASS.id;
             if ((biome == Biomes.OVERWORLD_RAINFOREST || biome == Biomes.OVERWORLD_SWAMPLAND || biome == Biomes.OVERWORLD_BOREAL_FOREST || biome == Biomes.OVERWORLD_TAIGA) && rand.nextInt(3) != 0) {
-                type = Block.tallgrassFern.id;
+                type = Blocks.TALLGRASS_FERN.id;
             }
             int l19 = x + rand.nextInt(16) + 8;
             int k22 = minY + rand.nextInt(rangeY);
             int j24 = z + rand.nextInt(16) + 8;
-            (new WorldFeatureTallGrass(type)).generate(world, rand, l19, k22, j24);
+            (new WorldFeatureTallGrass(type)).place(world, rand, l19, k22, j24);
         }
 
         byte1 = 0;
@@ -461,7 +477,7 @@ public class ChunkDecoratorOverworld
             int i17 = x + rand.nextInt(16) + 8;
             int i20 = minY + rand.nextInt(rangeY);
             int l22 = z + rand.nextInt(16) + 8;
-            (new WorldFeatureSpinifexPatch()).generate(world, rand, i17, i20, l22);
+            (new WorldFeatureSpinifexPatch()).place(world, rand, i17, i20, l22);
         }
 
         byte1 = 0;
@@ -475,32 +491,32 @@ public class ChunkDecoratorOverworld
             int i17 = x + rand.nextInt(16) + 8;
             int i20 = minY + rand.nextInt(rangeY);
             int l22 = z + rand.nextInt(16) + 8;
-            (new WorldFeatureDeadBush(Block.deadbush.id)).generate(world, rand, i17, i20, l22);
+            (new WorldFeatureDeadBush(Blocks.DEADBUSH.id)).place(world, rand, i17, i20, l22);
         }
 
         if (rand.nextInt(2) == 0) {
             int j15 = x + rand.nextInt(16) + 8;
             int j17 = minY + rand.nextInt(rangeY);
             int j20 = z + rand.nextInt(16) + 8;
-            (new WorldFeatureFlowers(Block.flowerRed.id)).generate(world, rand, j15, j17, j20);
+            (new WorldFeatureFlowers(Blocks.FLOWER_RED.id)).place(world, rand, j15, j17, j20);
         }
         if (rand.nextInt(4) == 0) {
             int k15 = x + rand.nextInt(16) + 8;
             int k17 = minY + rand.nextInt(rangeY);
             int k20 = z + rand.nextInt(16) + 8;
-            (new WorldFeatureFlowers(Block.mushroomBrown.id)).generate(world, rand, k15, k17, k20);
+            (new WorldFeatureFlowers(Blocks.MUSHROOM_BROWN.id)).place(world, rand, k15, k17, k20);
         }
         if (rand.nextInt(8) == 0) {
             int l15 = x + rand.nextInt(16) + 8;
             int l17 = minY + rand.nextInt(rangeY);
             int l20 = z + rand.nextInt(16) + 8;
-            (new WorldFeatureFlowers(Block.mushroomRed.id)).generate(world, rand, l15, l17, l20);
+            (new WorldFeatureFlowers(Blocks.MUSHROOM_RED.id)).place(world, rand, l15, l17, l20);
         }
         if(rand.nextInt(5) == 0) {
             int i18 = x + rand.nextInt(16) + 8;
             int i23 = z + rand.nextInt(16) + 8;
             int i21 = world.getHeightValue(i18, i23);
-            (new WorldFeatureSugarCane()).generate(world, rand, i18, i21, i23);
+            (new WorldFeatureSugarCane()).place(world, rand, i18, i21, i23);
         }
 
         if(rand.nextInt(128) == 0)
@@ -508,14 +524,14 @@ public class ChunkDecoratorOverworld
             int j16 = x + rand.nextInt(16) + 8;
             int j21 = z + rand.nextInt(16) + 8;
             int i22 = world.getHeightValue(j16, j21);
-            (new WorldFeaturePumpkin()).generate(world, rand, j16, i22, j21);
+            (new WorldFeaturePumpkin()).place(world, rand, j16, i22, j21);
         }
         if(rand.nextInt(64) == 0)
         {
             int j16 = x + rand.nextInt(16) + 8;
             int j21 = z + rand.nextInt(16) + 8;
             int i22 = world.getHeightValue(j16, j21);
-            (new WorldFeatureSponge()).generate(world, rand, j16, i22, j21);
+            (new WorldFeatureSponge()).place(world, rand, j16, i22, j21);
         }
 
         int k16 = 0;
@@ -532,7 +548,7 @@ public class ChunkDecoratorOverworld
             int k21 = x + rand.nextInt(16) + 8;
             int j23 = minY + rand.nextInt(rangeY);
             int k24 = z + rand.nextInt(16) + 8;
-            (new WorldFeatureCactus()).generate(world, rand, k21, j23, k24);
+            (new WorldFeatureCactus()).place(world, rand, k21, j23, k24);
         }
 
         for(int l18 = 0; l18 < 50; l18++)
@@ -540,7 +556,7 @@ public class ChunkDecoratorOverworld
             int l21 = x + rand.nextInt(16) + 8;
             int k23 = minY + rand.nextInt(rand.nextInt(rangeY - (rangeY / 16)) + (rangeY / 16));
             int l24 = z + rand.nextInt(16) + 8;
-            (new WorldFeatureLiquid(Block.fluidWaterFlowing.id)).generate(world, rand, l21, k23, l24);
+            (new WorldFeatureLiquid(Blocks.FLUID_WATER_FLOWING.id)).place(world, rand, l21, k23, l24);
         }
 
         for(int i19 = 0; i19 < 20; i19++)
@@ -548,7 +564,7 @@ public class ChunkDecoratorOverworld
             int i22 = x + rand.nextInt(16) + 8;
             int l23 = minY + rand.nextInt(rand.nextInt(rand.nextInt(rangeY - (rangeY / 8)) + (rangeY / 16)) + (rangeY / 16));
             int i25 = z + rand.nextInt(16) + 8;
-            (new WorldFeatureLiquid(Block.fluidLavaFlowing.id)).generate(world, rand, i22, l23, i25);
+            (new WorldFeatureLiquid(Blocks.FLUID_LAVA_FLOWING.id)).place(world, rand, i22, l23, i25);
         }
 
         int oceanY = world.getWorldType().getOceanY();
@@ -563,19 +579,19 @@ public class ChunkDecoratorOverworld
                 {
                     if (world.isAirBlock(dx, dy, dz) && world.getBlockMaterial(dx, dy - 1, dz).blocksMotion())
                     {
-                        world.setBlockWithNotify(dx, dy, dz, Block.layerSnow.id);
+                        world.setBlockWithNotify(dx, dy, dz, Blocks.LAYER_SNOW.id);
                     }
                 }
-                if ((localBiome.hasSurfaceSnow() || world.worldType == WorldTypes.OVERWORLD_WINTER) && (world.getBlockId(dx, oceanY - 1, dz) == Block.fluidWaterStill.id || world.getBlockId(dx, oceanY - 1, dz) == Block.fluidWaterFlowing.id))
+                if ((localBiome.hasSurfaceSnow() || world.worldType == WorldTypes.OVERWORLD_WINTER) && (world.getBlockId(dx, oceanY - 1, dz) == Blocks.FLUID_WATER_STILL.id || world.getBlockId(dx, oceanY - 1, dz) == Blocks.FLUID_WATER_FLOWING.id))
                 {
-                    world.setBlockWithNotify(dx, oceanY - 1, dz, Block.ice.id);
+                    world.setBlockWithNotify(dx, oceanY - 1, dz, Blocks.ICE.id);
                 }
 
             }
 
         }
 
-        BlockSand.fallInstantly = false;
+        SandBlock.fallInstantly = false;
         world.scheduledUpdatesAreImmediate = false;
     }
 }
